unit Oszi;

interface

uses I2CCOM2, PORTINC,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Messung: TButton;
    Messung2: TButton;
    K1: TButton;
    K2: TButton;
    K3: TButton;
    K4: TButton;
    Speichern: TButton;
    Clear: TButton;
    procedure FormCreate(Sender: TObject);
    procedure MessungClick(Sender: TObject);
    procedure K1Click(Sender: TObject);
    procedure K2Click(Sender: TObject);
    procedure K3Click(Sender: TObject);
    procedure K4Click(Sender: TObject);
    procedure Messung2Click(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure ClearClick(Sender: TObject);
  end;

var
  Form1: TForm1;
  Puffer : Array [1..4000] of Byte;
  DA_Puffer : Array [1..1000] of Byte;

implementation

{$R *.DFM}

procedure DAaus (Steuerbyte, Wert: Byte); begin
  Start;
  Ausgeben (72 * 2);       { Adresse 72, schreiben }
  Ausgeben (Steuerbyte);       
  Ausgeben (Wert);
  Stop;                        
end;                           

function ADein: Byte;          
begin
  Start;                       
  Ausgeben (72 * 2 + 1);   { Adresse 72, lesen }
  ADein := Einlesen;
  KeinAcknowledge;
  Stop;
end;

procedure AD_Serie;
var n: Integer;
    Dummy : Byte;
begin
  DAaus (5,100);               { Steuerbyte=5 }
  Start;
  Ausgeben (72 * 2 + 1);       { Adresse 72, lesen }
  RealTime (True);
  Dummy := Einlesen;
  Acknowledge;
  for n := 1 to 4000 do begin
    Puffer [n] := Einlesen;    { 4000 Bytes einlesen }
    Acknowledge;
  end;
  RealTime (False);
  Dummy := Einlesen;
  KeinAcknowledge;
  Stop;
end;

procedure DA_Tabelle;
var n : Integer;
begin
  for n := 1 to 250 do DA_Puffer [n] := 55;   
  for n := 251 to 450 do DA_Puffer [n] := 205;   
  for n := 451 to 1000 do DA_Puffer [n] := 55; 
end;

procedure AD_DA_Serie;
var n: Integer;
    Dummy : Byte;
begin
  RealTime(true);
  for n := 1 to 1000 do begin
    DAaus (69,DA_Puffer[n]);        { Steuerbyte=69 }
    Start;
    Ausgeben (72 * 2 + 1);          { Adresse 72, lesen }
    Dummy := Einlesen; Acknowledge;
    Puffer [4*(n-1)+1] := Einlesen; Acknowledge;
    DelayUs(10);
    Puffer [4*(n-1)+2] := Einlesen; Acknowledge;
    DelayUs(10);
    Puffer [4*(n-1)+3] := Einlesen; Acknowledge;
    DelayUs(10);
    Puffer [4*(n-1)+4] := Einlesen; KeinAcknowledge;
    DelayUs(20);
    Stop;
  end;
  RealTime(False);
end;

procedure SpeichernTabelle (Dateiname :String);
var  f : Text;
     n, r : Integer;
begin
  AssignFile(f,dateiname);
  {$I-} ReWrite(f); {$I+}
  r := IOresult;
  if  r = 0 then begin
     for n:=0 to 999 do begin;
       write (f,Puffer [4*n+1],#9);
       write (f,Puffer [4*n+2],#9);
       write (f,Puffer [4*n+3],#9);
       writeln (f,Puffer [4*n+4]);
     end;
     CloseFile (f);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  I2C_Init;
  DA_Tabelle;
end;

procedure DiagrammInit;
var n: Integer;
begin
  with Form1.Paintbox1.Canvas do begin
  Pen.Color:=ClBlack;
  Brush.Color:=ClWhite;
  Rectangle(30,0,531,257);
  Pen.Color:=ClLtGray;
  for n:= 1 to 10 do begin
      MoveTo(31,256-n*25);
      Lineto (529,256-n*25);
  end;
  Brush.Color:=ClLtGray;
  for n:= 0 to 5 do begin
    TextOut(10,250-n*50,FloatToStr(n)+' V');
  end;
  for n:= 1 to 9 do begin
      MoveTo(30+50*n,254);
      Lineto (30+50*n,0)
  end;
  for n:= 1 to 10 do begin
    TextOut(20+50*n,260,FloatToStr(n*100));
  end;
  end;
end;

procedure Plot (Kanal: Integer);
var i: Integer;
begin
  with Form1.Paintbox1.Canvas do begin
    Pen.Color:=ClBlack;
    MoveTo (31,256-Puffer[4+Kanal]);
    for i := 1 to 999 do
      LineTo (31+i div 2,256-Puffer[i*4+Kanal]);
  end;
end;

procedure TForm1.MessungClick(Sender: TObject);
begin
  DiagrammInit;
  AD_Serie;
end;

procedure TForm1.K1Click(Sender: TObject);
begin
  plot(0);
end;

procedure TForm1.K2Click(Sender: TObject);
begin
  Plot (1);
end;

procedure TForm1.K3Click(Sender: TObject);
begin
  Plot(2);
end;

procedure TForm1.K4Click(Sender: TObject);
begin
  Plot(3);
end;

procedure TForm1.Messung2Click(Sender: TObject);
begin
  DiagrammInit;
  AD_DA_Serie;
end;

procedure TForm1.SpeichernClick(Sender: TObject);
begin
  SpeichernTabelle('Ausgabe.dat');
end;

procedure TForm1.ClearClick(Sender: TObject);
begin
  DiagrammInit;
end;

end.

